]> Git Repo - u-boot.git/blame - Makefile
serial: mtk: rewrite the setbrg function
[u-boot.git] / Makefile
CommitLineData
83d290c5 1# SPDX-License-Identifier: GPL-2.0+
da58dec8 2
81a659e1 3VERSION = 2021
1aa9c3b9 4PATCHLEVEL = 04
211e4754 5SUBLEVEL =
4103e135 6EXTRAVERSION = -rc4
5f30f3be 7NAME =
ae6d1056 8
6825a95b
MY
9# *DOCUMENTATION*
10# To see a list of typical targets execute "make help"
11# More info can be located in ./README
12# Comments in this file are targeted only to the developer, do not
13# expect to learn how to build the kernel reading this file.
14
4d713be1
MY
15# o Do not use make's built-in rules and variables
16# (this increases performance and avoids hard-to-debug behaviour);
17# o Look for make include files relative to root of kernel src
18MAKEFLAGS += -rR --include-dir=$(CURDIR)
6825a95b 19
3b4847cb
HS
20# Determine host architecture
21include include/host_arch.h
22MK_ARCH="${shell uname -m}"
23unexport HOST_ARCH
24ifeq ("x86_64", $(MK_ARCH))
25 export HOST_ARCH=$(HOST_ARCH_X86_64)
26else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
27 export HOST_ARCH=$(HOST_ARCH_X86)
28else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
29 export HOST_ARCH=$(HOST_ARCH_AARCH64)
30else ifeq ("armv7l", $(MK_ARCH))
31 export HOST_ARCH=$(HOST_ARCH_ARM)
32else ifeq ("riscv32", $(MK_ARCH))
33 export HOST_ARCH=$(HOST_ARCH_RISCV32)
34else ifeq ("riscv64", $(MK_ARCH))
35 export HOST_ARCH=$(HOST_ARCH_RISCV64)
36endif
37undefine MK_ARCH
38
6825a95b
MY
39# Avoid funny character set dependencies
40unexport LC_ALL
41LC_COLLATE=C
42LC_NUMERIC=C
43export LC_COLLATE LC_NUMERIC
44
ffe29ebc
MY
45# Avoid interference with shell env settings
46unexport GREP_OPTIONS
47
6825a95b
MY
48# We are using a recursive build, so we need to do a little thinking
49# to get the ordering right.
50#
51# Most importantly: sub-Makefiles should only ever modify files in
52# their own directory. If in some directory we have a dependency on
53# a file in another dir (which doesn't happen often, but it's often
54# unavoidable when linking the built-in.o targets which finally
55# turn into vmlinux), we will call a sub make in that other dir, and
56# after that we are sure that everything which is in that other dir
57# is now up to date.
58#
59# The only cases where we need to modify files which have global
60# effects are thus separated out and done before the recursive
61# descending is started. They are now explicitly listed as the
62# prepare rule.
63
ffe29ebc
MY
64# Beautify output
65# ---------------------------------------------------------------------------
66#
67# Normally, we echo the whole command before executing it. By making
68# that echo $($(quiet)$(cmd)), we now have the possibility to set
69# $(quiet) to choose other forms of output instead, e.g.
70#
71# quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
72# cmd_cc_o_c = $(CC) $(c_flags) -c -o $@ $<
73#
74# If $(quiet) is empty, the whole command will be printed.
75# If it is set to "quiet_", only the short version will be printed.
76# If it is set to "silent_", nothing will be printed at all, since
77# the variable $(silent_cmd_cc_o_c) doesn't exist.
78#
79# A simple variant is to prefix commands with $(Q) - that's useful
80# for commands that shall be hidden in non-verbose mode.
81#
82# $(Q)ln $@ :<
83#
84# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
85# If KBUILD_VERBOSE equals 1 then the above command is displayed.
86#
6825a95b
MY
87# To put more focus on warnings, be less verbose as default
88# Use 'make V=1' to see the full commands
89
90ifeq ("$(origin V)", "command line")
91 KBUILD_VERBOSE = $(V)
92endif
93ifndef KBUILD_VERBOSE
94 KBUILD_VERBOSE = 0
95endif
96
ffe29ebc
MY
97ifeq ($(KBUILD_VERBOSE),1)
98 quiet =
99 Q =
100else
101 quiet=quiet_
102 Q = @
103endif
6825a95b 104
ffe29ebc
MY
105# If the user is running make -s (silent mode), suppress echoing of
106# commands
107
108ifneq ($(filter 4.%,$(MAKE_VERSION)),) # make-4
109ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
110 quiet=silent_
6825a95b 111endif
ffe29ebc
MY
112else # make-3.8x
113ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
114 quiet=silent_
6825a95b 115endif
6825a95b
MY
116endif
117
ffe29ebc 118export quiet Q KBUILD_VERBOSE
6825a95b 119
9e414032
MY
120# kbuild supports saving output files in a separate directory.
121# To locate output files in a separate directory two syntaxes are supported.
122# In both cases the working directory must be the root of the kernel src.
123# 1) O=
124# Use "make O=dir/to/store/output/files/"
887e2ec9 125#
9e414032
MY
126# 2) Set KBUILD_OUTPUT
127# Set the environment variable KBUILD_OUTPUT to point to the directory
128# where the output files shall be placed.
129# export KBUILD_OUTPUT=dir/to/store/output/files/
130# make
887e2ec9 131#
9e414032
MY
132# The O= assignment takes precedence over the KBUILD_OUTPUT environment
133# variable.
134
9e414032
MY
135# KBUILD_SRC is set on invocation of make in OBJ directory
136# KBUILD_SRC is not intended to be used by the regular user (for now)
137ifeq ($(KBUILD_SRC),)
f9328639 138
9e414032
MY
139# OK, Make called in directory where kernel src resides
140# Do we want to locate output files in a separate directory?
f9328639 141ifeq ("$(origin O)", "command line")
9e414032
MY
142 KBUILD_OUTPUT := $(O)
143endif
144
9e414032
MY
145# That's our default target when none is given on the command line
146PHONY := _all
147_all:
148
149# Cancel implicit rules on top Makefile
150$(CURDIR)/Makefile Makefile: ;
151
152ifneq ($(KBUILD_OUTPUT),)
153# Invoke a second make in the output directory, passing relevant variables
154# check that the output directory actually exists
155saved-output := $(KBUILD_OUTPUT)
5a449d75
MY
156KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
157 && /bin/pwd)
9e414032 158$(if $(KBUILD_OUTPUT),, \
598e2d33 159 $(error failed to create output directory "$(saved-output)"))
9e414032
MY
160
161PHONY += $(MAKECMDGOALS) sub-make
162
163$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
164 @:
165
166sub-make: FORCE
ffe29ebc
MY
167 $(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
168 -f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
9e414032
MY
169
170# Leave processing to above invocation of make
171skip-makefile := 1
172endif # ifneq ($(KBUILD_OUTPUT),)
173endif # ifeq ($(KBUILD_SRC),)
174
175# We process the rest of the Makefile if this is the final invocation of make
176ifeq ($(skip-makefile),)
177
ffe29ebc
MY
178# Do not print "Entering directory ...",
179# but we want to display it when entering to the output directory
180# so that IDEs/editors are able to understand relative filenames.
181MAKEFLAGS += --no-print-directory
182
183# Call a source code checker (by default, "sparse") as part of the
184# C compilation.
185#
186# Use 'make C=1' to enable checking of only re-compiled files.
187# Use 'make C=2' to enable checking of *all* source files, regardless
188# of whether they are re-compiled or not.
189#
656d8da9 190# See the file "doc/sparse.txt" for more details, including
ffe29ebc
MY
191# where to get the "sparse" utility.
192
193ifeq ("$(origin C)", "command line")
194 KBUILD_CHECKSRC = $(C)
195endif
196ifndef KBUILD_CHECKSRC
197 KBUILD_CHECKSRC = 0
198endif
199
200# Use make M=dir to specify directory of external module to build
201# Old syntax make ... SUBDIRS=$PWD is still supported
202# Setting the environment variable KBUILD_EXTMOD take precedence
203ifdef SUBDIRS
204 KBUILD_EXTMOD ?= $(SUBDIRS)
205endif
206
207ifeq ("$(origin M)", "command line")
208 KBUILD_EXTMOD := $(M)
209endif
210
6825a95b
MY
211# If building an external module we do not care about the all: rule
212# but instead _all depend on modules
9e414032 213PHONY += all
6825a95b 214ifeq ($(KBUILD_EXTMOD),)
9e414032 215_all: all
8b9e4787 216else
6825a95b 217_all: modules
8b9e4787 218endif
9e414032 219
ffe29ebc
MY
220ifeq ($(KBUILD_SRC),)
221 # building in the source tree
222 srctree := .
223else
224 ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
225 # building in a subdirectory of the source tree
226 srctree := ..
227 else
228 srctree := $(KBUILD_SRC)
229 endif
230endif
231objtree := .
9e414032
MY
232src := $(srctree)
233obj := $(objtree)
234
235VPATH := $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
236
237export srctree objtree VPATH
238
5013c09f
WD
239# Make sure CDPATH settings don't interfere
240unexport CDPATH
241
7ebf7443
WD
242#########################################################################
243
7ebf7443 244HOSTARCH := $(shell uname -m | \
fea25720 245 sed -e s/i.86/x86/ \
7ebf7443
WD
246 -e s/sun4u/sparc64/ \
247 -e s/arm.*/arm/ \
248 -e s/sa110/arm/ \
d0179083
KG
249 -e s/ppc64/powerpc/ \
250 -e s/ppc/powerpc/ \
8d1f6355
NI
251 -e s/macppc/powerpc/\
252 -e s/sh.*/sh/)
7ebf7443 253
f9d77ed3 254HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
7ebf7443
WD
255 sed -e 's/\(cygwin\).*/cygwin/')
256
120ae609 257export HOSTARCH HOSTOS
7ebf7443 258
ae6d1056 259#########################################################################
5f30f3be 260
1ea6bcd8 261# set default to nothing for native builds
a5284efd 262ifeq ($(HOSTARCH),$(ARCH))
1ea6bcd8 263CROSS_COMPILE ?=
ae6d1056
WD
264endif
265
51148790
MY
266KCONFIG_CONFIG ?= .config
267export KCONFIG_CONFIG
268
f6322eb7
MY
269# SHELL used by kbuild
270CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
271 else if [ -x /bin/bash ]; then echo /bin/bash; \
272 else echo sh; fi ; fi)
273
587e4a42
TR
274HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
275HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
276HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
277
b477fe44
JH
278HOSTCC = cc
279HOSTCXX = c++
587e4a42 280KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
b47ef6b0 281 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
587e4a42
TR
282KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
283KBUILD_HOSTLDFLAGS := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
284KBUILD_HOSTLDLIBS := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
598e2d33 285
9de4f959
PT
286# With the move to GCC 6, we have implicitly upgraded our language
287# standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
288# Some Linux distributions (including RHEL7, SLES13, Debian 8) still
289# have older compilers as their default, so we make it explicit for
290# these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
fa893990 291CSTD_FLAG := -std=gnu11
9de4f959 292ifeq ($(HOSTOS),linux)
587e4a42 293KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
9de4f959
PT
294endif
295
f6322eb7 296ifeq ($(HOSTOS),cygwin)
587e4a42 297KBUILD_HOSTCFLAGS += -ansi
f6322eb7
MY
298endif
299
300# Mac OS X / Darwin's C preprocessor is Apple specific. It
301# generates numerous errors and warnings. We want to bypass it
302# and use GNU C's cpp. To do this we pass the -traditional-cpp
303# option to the compiler. Note that the -traditional-cpp flag
304# DOES NOT have the same semantics as GNU C's flag, all it does
305# is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
f9328639 306#
f6322eb7
MY
307# Apple's linker is similar, thanks to the new 2 stage linking
308# multiple symbol definitions are treated as errors, hence the
309# -multiply_defined suppress option to turn off this error.
887e2ec9 310#
f6322eb7
MY
311ifeq ($(HOSTOS),darwin)
312# get major and minor product version (e.g. '10' and '6' for Snow Leopard)
313DARWIN_MAJOR_VERSION = $(shell sw_vers -productVersion | cut -f 1 -d '.')
314DARWIN_MINOR_VERSION = $(shell sw_vers -productVersion | cut -f 2 -d '.')
315
316os_x_before = $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
317 $(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
318
ab8fc413 319os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
320 $(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
321
f6322eb7
MY
322# Snow Leopards build environment has no longer restrictions as described above
323HOSTCC = $(call os_x_before, 10, 5, "cc", "gcc")
587e4a42
TR
324KBUILD_HOSTCFLAGS += $(call os_x_before, 10, 4, "-traditional-cpp")
325KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
1fddd7b6
AB
326
327# since Lion (10.7) ASLR is on by default, but we use linker generated lists
328# in some host tools which is a problem then ... so disable ASLR for these
329# tools
587e4a42 330KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 7, "", "-Xlinker -no_pie")
ab8fc413 331
332# macOS Mojave (10.14.X)
333# Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
587e4a42 334KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
f6322eb7
MY
335endif
336
6825a95b
MY
337# Decide whether to build built-in, modular, or both.
338# Normally, just do built-in.
339
340KBUILD_MODULES :=
341KBUILD_BUILTIN := 1
342
45f0ad95
MY
343# If we have only "make modules", don't compile built-in objects.
344# When we're building modules with modversions, we need to consider
345# the built-in objects during the descend as well, in order to
346# make sure the checksums are up to date before we record them.
6825a95b
MY
347
348ifeq ($(MAKECMDGOALS),modules)
349 KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
350endif
351
45f0ad95
MY
352# If we have "make <whatever> modules", compile modules
353# in addition to whatever we do anyway.
354# Just "make" or "make all" shall build modules as well
6825a95b
MY
355
356# U-Boot does not need modules
357#ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
358# KBUILD_MODULES := 1
359#endif
360
361#ifeq ($(MAKECMDGOALS),)
362# KBUILD_MODULES := 1
363#endif
364
b51882d0
SG
365# Check ths size of a binary:
366# Args:
367# $1: File to check
368# #2: Size limit in bytes (decimal or 0xhex)
b275030e
HS
369define size_check
370 actual=$$( wc -c $1 | awk '{print $$1}'); \
371 limit=$$( printf "%d" $2 ); \
372 if test $$actual -gt $$limit; then \
373 echo "$1 exceeds file size limit:" >&2; \
90037eb4 374 echo " limit: $$(printf %#x $$limit) bytes" >&2; \
b51882d0
SG
375 echo " actual: $$(printf %#x $$actual) bytes" >&2; \
376 echo " excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
b275030e
HS
377 exit 1; \
378 fi
379endef
380export size_check
381
6825a95b
MY
382export KBUILD_MODULES KBUILD_BUILTIN
383export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
384
bf4b3de1 385# We need some generic definitions (do not try to remake the file).
4d713be1
MY
386scripts/Kbuild.include: ;
387include scripts/Kbuild.include
f9328639 388
f6322eb7 389# Make variables (CC, etc...)
7ebf7443 390
f6322eb7
MY
391AS = $(CROSS_COMPILE)as
392# Always use GNU ld
393ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
394LD = $(CROSS_COMPILE)ld.bfd
f9328639 395else
f6322eb7
MY
396LD = $(CROSS_COMPILE)ld
397endif
398CC = $(CROSS_COMPILE)gcc
399CPP = $(CC) -E
400AR = $(CROSS_COMPILE)ar
401NM = $(CROSS_COMPILE)nm
402LDR = $(CROSS_COMPILE)ldr
403STRIP = $(CROSS_COMPILE)strip
404OBJCOPY = $(CROSS_COMPILE)objcopy
405OBJDUMP = $(CROSS_COMPILE)objdump
e91610da
ER
406LEX = flex
407YACC = bison
f6322eb7 408AWK = awk
f77d7096 409PERL = perl
b48bfc74 410PYTHON ?= python
e91610da
ER
411PYTHON2 = python2
412PYTHON3 = python3
36dd5f1b 413DTC ?= $(objtree)/scripts/dtc/dtc
f6322eb7
MY
414CHECK = sparse
415
416CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
417 -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
418
3b612970 419KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
2b3c9d3d
MY
420
421KBUILD_CFLAGS := -Wall -Wstrict-prototypes \
422 -Wno-format-security \
fa893990 423 -fno-builtin -ffreestanding $(CSTD_FLAG)
5bc11922 424KBUILD_CFLAGS += -fshort-wchar -fno-strict-aliasing
2b3c9d3d 425KBUILD_AFLAGS := -D__ASSEMBLY__
587e4a42
TR
426KBUILD_LDFLAGS :=
427
428ifeq ($(cc-name),clang)
429ifneq ($(CROSS_COMPILE),)
430CLANG_TARGET := --target=$(notdir $(CROSS_COMPILE:%-=%))
431GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
432CLANG_PREFIX := --prefix=$(GCC_TOOLCHAIN_DIR)
433GCC_TOOLCHAIN := $(realpath $(GCC_TOOLCHAIN_DIR)/..)
434endif
435ifneq ($(GCC_TOOLCHAIN),)
436CLANG_GCC_TC := --gcc-toolchain=$(GCC_TOOLCHAIN)
437endif
438KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
439KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
440KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
441KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
442endif
2b3c9d3d 443
6ace36e1
AS
444# Don't generate position independent code
445KBUILD_CFLAGS += $(call cc-option,-fno-PIE)
446KBUILD_AFLAGS += $(call cc-option,-fno-PIE)
447
7424145f
MY
448# Read UBOOTRELEASE from include/config/uboot.release (if it exists)
449UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
450UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
5f30f3be 451
7424145f 452export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
026f9cf2 453export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
587e4a42
TR
454export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
455export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
e91610da 456export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
587e4a42 457export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
f6322eb7 458
587e4a42 459export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
2b3c9d3d
MY
460export KBUILD_CFLAGS KBUILD_AFLAGS
461
5972ff07
TR
462export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
463
6825a95b
MY
464# When compiling out-of-tree modules, put MODVERDIR in the module
465# tree rather than in the kernel tree. The kernel tree might
466# even be read-only.
467export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
468
469# Files to ignore in find ... statements
470
598e2d33
MY
471export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o \
472 -name CVS -o -name .pc -o -name .hg -o -name .git \) \
473 -prune -o
6825a95b
MY
474export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
475 --exclude CVS --exclude .pc --exclude .hg --exclude .git
476
477# ===========================================================================
478# Rules shared between *config targets and build targets
479
480# Basic helpers built in scripts/
481PHONY += scripts_basic
482scripts_basic:
483 $(Q)$(MAKE) $(build)=scripts/basic
484 $(Q)rm -f .tmp_quiet_recordmcount
485
486# To avoid any implicit rule to kick in, define an empty command.
487scripts/basic/%: scripts_basic ;
488
3341bfec
MY
489PHONY += outputmakefile
490# outputmakefile generates a Makefile in the output directory, if using a
491# separate output directory. This allows convenient use of make in the
492# output directory.
493outputmakefile:
494ifneq ($(KBUILD_SRC),)
495 $(Q)ln -fsn $(srctree) source
496 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile \
497 $(srctree) $(objtree) $(VERSION) $(PATCHLEVEL)
887e2ec9 498endif
f9328639 499
433b2f1e
MY
500# To make sure we do not include .config for any of the *config targets
501# catch them early, and hand them over to scripts/kconfig/Makefile
502# It is allowed to specify more targets when calling make, including
503# mixing *config targets and build targets.
504# For example 'make oldconfig all'.
505# Detect when mixed targets is specified, and make a second invocation
506# of make so .config is not included in this case either (for *config).
507
7424145f
MY
508version_h := include/generated/version_autogenerated.h
509timestamp_h := include/generated/timestamp_autogenerated.h
f3d8f7dd 510defaultenv_h := include/generated/defaultenv_autogenerated.h
dacec83c 511dt_h := include/generated/dt.h
7424145f 512
433b2f1e 513no-dot-config-targets := clean clobber mrproper distclean \
27651187 514 help %docs check% coccicheck \
76160801 515 ubootversion backup tests check qcheck tcheck
433b2f1e
MY
516
517config-targets := 0
518mixed-targets := 0
519dot-config := 1
520
521ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
522 ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
523 dot-config := 0
524 endif
525endif
5013c09f 526
433b2f1e
MY
527ifeq ($(KBUILD_EXTMOD),)
528 ifneq ($(filter config %config,$(MAKECMDGOALS)),)
529 config-targets := 1
98bd0e0d 530 ifneq ($(words $(MAKECMDGOALS)),1)
433b2f1e
MY
531 mixed-targets := 1
532 endif
533 endif
2b3c9d3d 534endif
7ebf7443 535
433b2f1e
MY
536ifeq ($(mixed-targets),1)
537# ===========================================================================
538# We're called with mixed targets (*config and build targets).
539# Handle them one by one.
2b3c9d3d 540
e7734404 541PHONY += $(MAKECMDGOALS) __build_one_by_one
6d1ce387 542
e7734404 543$(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
53bca5ab
MY
544 @:
545
e7734404 546__build_one_by_one:
53bca5ab
MY
547 $(Q)set -e; \
548 for i in $(MAKECMDGOALS); do \
549 $(MAKE) -f $(srctree)/Makefile $$i; \
550 done
6d1ce387 551
433b2f1e
MY
552else
553ifeq ($(config-targets),1)
554# ===========================================================================
555# *config targets only - make sure prerequisites are updated, and descend
556# in scripts/kconfig to make the *config target
7ebf7443 557
51148790
MY
558KBUILD_DEFCONFIG := sandbox_defconfig
559export KBUILD_DEFCONFIG KBUILD_KCONFIG
2632c008 560
51148790 561config: scripts_basic outputmakefile FORCE
5f9eb220 562 $(Q)$(MAKE) $(build)=scripts/kconfig $@
51148790
MY
563
564%config: scripts_basic outputmakefile FORCE
5f9eb220 565 $(Q)$(MAKE) $(build)=scripts/kconfig $@
2b3c9d3d 566
433b2f1e
MY
567else
568# ===========================================================================
569# Build targets only - this includes vmlinux, arch specific targets, clean
570# targets and others. In general all targets except *config targets.
b5728756 571
61304dbe
MY
572# Additional helpers built in scripts/
573# Carefully list dependencies so we do not try to build scripts twice
574# in parallel
575PHONY += scripts
576scripts: scripts_basic include/config/auto.conf
577 $(Q)$(MAKE) $(build)=$(@)
578
433b2f1e
MY
579ifeq ($(dot-config),1)
580# Read in config
51148790
MY
581-include include/config/auto.conf
582
583# Read in dependencies to all Kconfig* files, make sure to run
584# oldconfig if changes are detected.
585-include include/config/auto.conf.cmd
586
587# To avoid any implicit rule to kick in, define an empty command
588$(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
589
590# If .config is newer than include/config/auto.conf, someone tinkered
591# with it and forgot to run make oldconfig.
592# if auto.conf.cmd is missing then we are probably in a cleaned tree so
593# we execute the config step to be sure to catch updated Kconfig files
594include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
e91610da 595 $(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
5f9eb220
MY
596 @# If the following part fails, include/config/auto.conf should be
597 @# deleted so "make silentoldconfig" will be re-run on the next build.
598 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
599 { rm -f include/config/auto.conf; false; }
600 @# include/config.h has been updated after "make silentoldconfig".
601 @# We need to touch include/config/auto.conf so it gets newer
602 @# than include/config.h.
603 @# Otherwise, 'make silentoldconfig' would be invoked twice.
604 $(Q)touch include/config/auto.conf
51148790 605
0b588def 606u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
0d982c58
PT
607 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
608
433b2f1e
MY
609-include include/autoconf.mk
610-include include/autoconf.mk.dep
7ebf7443 611
51148790
MY
612# We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
613# is up-to-date. When we switch to a different board configuration, old CONFIG
614# macros are still remaining in include/config/auto.conf. Without the following
615# gimmick, wrong config.mk would be included leading nasty warnings/errors.
cffcd286
MY
616ifneq ($(wildcard $(KCONFIG_CONFIG)),)
617ifneq ($(wildcard include/config/auto.conf),)
618autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
619 include/config/auto.conf)
620ifeq ($(autoconf_is_old),)
4d713be1
MY
621include config.mk
622include arch/$(ARCH)/Makefile
ced0715d 623endif
cffcd286
MY
624endif
625endif
fada9e20 626
bb1ae559
SG
627# These are set by the arch-specific config.mk. Make sure they are exported
628# so they can be used when building an EFI application.
629export EFI_LDS # Filename of EFI link script in arch/$(ARCH)/lib
630export EFI_CRT0 # Filename of EFI CRT0 in arch/$(ARCH)/lib
631export EFI_RELOC # Filename of EFU relocation code in arch/$(ARCH)/lib
632export CFLAGS_EFI # Compiler flags to add when building EFI app
633export CFLAGS_NON_EFI # Compiler flags to remove when building EFI app
634export EFI_TARGET # binutils target if EFI is natively supported
635
d51dfff7
IY
636# If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
637# that (or fail if absent). Otherwise, search for a linker script in a
638# standard location.
639
640ifndef LDSCRIPT
4379ac61 641 #LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
d51dfff7
IY
642 ifdef CONFIG_SYS_LDSCRIPT
643 # need to strip off double quotes
4a377552 644 LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
d51dfff7
IY
645 endif
646endif
647
ee60197e 648# If there is no specified link script, we look in a number of places for it
d51dfff7 649ifndef LDSCRIPT
d51dfff7 650 ifeq ($(wildcard $(LDSCRIPT)),)
4379ac61 651 LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
d51dfff7
IY
652 endif
653 ifeq ($(wildcard $(LDSCRIPT)),)
4379ac61 654 LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
d51dfff7 655 endif
ee60197e 656 ifeq ($(wildcard $(LDSCRIPT)),)
4379ac61 657 LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
ee60197e 658 endif
d51dfff7
IY
659endif
660
433b2f1e 661else
51148790
MY
662# Dummy target needed, because used as prerequisite
663include/config/auto.conf: ;
433b2f1e
MY
664endif # $(dot-config)
665
de5e5cea
CZ
666#
667# Xtensa linker script cannot be preprocessed with -ansi because of
668# preprocessor operations on strings that don't make C identifiers.
669#
670ifeq ($(CONFIG_XTENSA),)
671LDPPFLAGS += -ansi
672endif
673
4a8ed8e2
MY
674ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
675KBUILD_CFLAGS += -Os
676else
677KBUILD_CFLAGS += -O2
678endif
433b2f1e 679
433b2f1e 680KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
687a7518 681KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
433b2f1e 682
587e4a42
TR
683# disable stringop warnings in gcc 8+
684KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
685
443f2236
TR
686# Enabled with W=2, disabled by default as noisy
687KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
688
1eb2e71e
MY
689# change __FILE__ to the relative path from the srctree
690KBUILD_CFLAGS += $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
691
433b2f1e
MY
692KBUILD_CFLAGS += -g
693# $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
694# option to the assembler.
695KBUILD_AFLAGS += -g
696
697# Report stack usage if supported
948071ba
AB
698# ARC tools based on GCC 7.1 has an issue with stack usage
699# with naked functions, see commit message for more details
700ifndef CONFIG_ARC
5b1f1f4a
MY
701ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
702 KBUILD_CFLAGS += -fstack-usage
703endif
948071ba 704endif
433b2f1e
MY
705
706KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
53dc8ae6
AS
707KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
708
4760fe26
TR
709ifeq ($(cc-name),clang)
710KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
711KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
712KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
587e4a42
TR
713KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
714# Quiet clang warning: comparison of unsigned expression < 0 is always false
715KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
716# CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
717# source of a reference will be _MergedGlobals and not on of the whitelisted names.
718# See modpost pattern 2
719KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
4760fe26 720KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
587e4a42
TR
721else
722
723# These warnings generated too much noise in a regular build.
724# Use make W=1 to enable them (see scripts/Makefile.extrawarn)
725KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
4760fe26 726endif
433b2f1e 727
65bb6d8d
MY
728# Prohibit date/time macros, which would make the build non-deterministic
729KBUILD_CFLAGS += $(call cc-option,-Werror=date-time)
730
4d713be1 731include scripts/Makefile.extrawarn
6419e144 732
0e6256d0
MY
733# Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
734KBUILD_CPPFLAGS += $(KCPPFLAGS)
735KBUILD_AFLAGS += $(KAFLAGS)
736KBUILD_CFLAGS += $(KCFLAGS)
737
b47ef6b0
SG
738KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
739
433b2f1e
MY
740# Use UBOOTINCLUDE when you must reference the include/ directory.
741# Needed to be compatible with the O= option
f5c66bdb 742UBOOTINCLUDE := \
0053d26b
HS
743 -Iinclude \
744 $(if $(KBUILD_SRC), -I$(srctree)/include) \
745 $(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
746 $(if $(CONFIG_HAS_THUMB2), \
747 $(if $(CONFIG_CPU_V7M), \
748 -I$(srctree)/arch/arm/thumb1/include), \
749 -I$(srctree)/arch/arm/thumb1/include)) \
750 -I$(srctree)/arch/$(ARCH)/include \
751 -include $(srctree)/include/linux/kconfig.h
433b2f1e
MY
752
753NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
433b2f1e
MY
754
755# FIX ME
026f9cf2
MY
756cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
757 $(NOSTDINC_FLAGS)
433b2f1e
MY
758c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
759
7ebf7443
WD
760#########################################################################
761# U-Boot objects....order is important (i.e. start must be first)
762
9e414032 763HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
8b5a0264 764
656de6b8
MY
765libs-y += lib/
766libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
656de6b8 767libs-$(CONFIG_OF_EMBED) += dts/
656de6b8
MY
768libs-y += fs/
769libs-y += net/
770libs-y += disk/
771libs-y += drivers/
772libs-y += drivers/dma/
773libs-y += drivers/gpio/
774libs-y += drivers/i2c/
656de6b8
MY
775libs-y += drivers/net/
776libs-y += drivers/net/phy/
656de6b8 777libs-y += drivers/power/ \
61f5ddcb 778 drivers/power/domain/ \
e2906a59
MY
779 drivers/power/fuel_gauge/ \
780 drivers/power/mfd/ \
781 drivers/power/pmic/ \
af41e8db
PM
782 drivers/power/battery/ \
783 drivers/power/regulator/
656de6b8
MY
784libs-y += drivers/spi/
785libs-$(CONFIG_FMAN_ENET) += drivers/net/fm/
786libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
b9e745bb 787libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
5918afda 788libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
656de6b8 789libs-y += drivers/serial/
7e91f6cc 790libs-y += drivers/usb/cdns3/
5b9ce0e2 791libs-y += drivers/usb/dwc3/
93eb8f39 792libs-y += drivers/usb/common/
019808f9 793libs-y += drivers/usb/emul/
656de6b8 794libs-y += drivers/usb/eth/
4cc53ef1 795libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
db17a92d
JJH
796libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
797libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
656de6b8 798libs-y += drivers/usb/host/
e09b88cd 799libs-y += drivers/usb/mtu3/
656de6b8
MY
800libs-y += drivers/usb/musb/
801libs-y += drivers/usb/musb-new/
802libs-y += drivers/usb/phy/
803libs-y += drivers/usb/ulpi/
72a8cf8d 804libs-y += cmd/
656de6b8 805libs-y += common/
0649cd0d 806libs-y += env/
656de6b8 807libs-$(CONFIG_API) += api/
50fbd5c8
SG
808ifdef CONFIG_POST
809libs-y += post/
810endif
16a50683 811libs-$(CONFIG_UNIT_TEST) += test/
421f86f3 812libs-$(CONFIG_UT_ENV) += test/env/
96383bdf 813libs-$(CONFIG_UT_OPTEE) += test/optee/
f2a9942f 814libs-$(CONFIG_UT_OVERLAY) += test/overlay/
f9328639 815
33a02da0 816libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
656de6b8
MY
817
818libs-y := $(sort $(libs-y))
852bd07c 819
656de6b8
MY
820u-boot-dirs := $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
821
822u-boot-alldirs := $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
823
824libs-y := $(patsubst %/, %/built-in.o, $(libs-y))
825
826u-boot-init := $(head-y)
827u-boot-main := $(libs-y)
08e39a84 828
a8c7c708 829
4f7cb08e 830# Add GCC lib
cd2e46cb 831ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
a86cf89c 832PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
52b1bf2c 833else
6825a95b 834PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
52b1bf2c
WD
835endif
836PLATFORM_LIBS += $(PLATFORM_LIBGCC)
52ff8020
CG
837
838ifdef CONFIG_CC_COVERAGE
839KBUILD_CFLAGS += --coverage
840PLATFORM_LIBGCC += -lgcov
841endif
842
52b1bf2c 843export PLATFORM_LIBS
e75e73dd 844export PLATFORM_LIBGCC
3d3befa7 845
6ac9f479
MF
846# Special flags for CPP when processing the linker script.
847# Pass the version down so we can handle backwards compatibility
848# on the fly.
849LDPPFLAGS += \
4379ac61 850 -include $(srctree)/include/u-boot/u-boot.lds.h \
7e6403a6 851 -DCPUDIR=$(CPUDIR) \
6ac9f479
MF
852 $(shell $(LD) --version | \
853 sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
854
bdccc4fe 855#########################################################################
7ebf7443
WD
856#########################################################################
857
f3a14d37 858ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
b275030e 859BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
f3a14d37
MF
860else
861BOARD_SIZE_CHECK =
862endif
863
2dfdd0c4 864ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
2577015d 865SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
0a0f2314
HS
866else
867SPL_SIZE_CHECK =
868endif
869
2dfdd0c4 870ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
c52b5e8e
SG
871TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
872else
873TPL_SIZE_CHECK =
874endif
875
8137af19 876# Statically apply RELA-style relocations (currently arm64 only)
d57259b9
ÁFR
877# This is useful for arm64 where static relocation needs to be performed on
878# the raw binary, but certain simulators only accept an ELF file (but don't
879# do the relocation).
8137af19
SW
880ifneq ($(CONFIG_STATIC_RELA),)
881# $(1) is u-boot ELF, $(2) is u-boot bin, $(3) is text base
7125d2c1
JK
882quiet_cmd_static_rela = RELOC $@
883cmd_static_rela = \
884 start=$$($(NM) $(2) | grep __rel_dyn_start | cut -f 1 -d ' '); \
885 end=$$($(NM) $(2) | grep __rel_dyn_end | cut -f 1 -d ' '); \
886 tools/relocate-rela $(3) $(4) $$start $$end
8137af19 887else
7125d2c1 888quiet_cmd_static_rela =
e9ebc17e 889cmd_static_rela =
8137af19
SW
890endif
891
e6385c7e
SG
892# Always append INPUTS so that arch config.mk's can add custom ones
893INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
9e414032 894
e6385c7e 895INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
89ad7be8 896ifeq ($(CONFIG_SPL_FSL_PBL),y)
e6385c7e 897INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
89ad7be8 898else
bba4c7f9 899ifneq ($(CONFIG_NXP_ESBC), y)
467a40df
AB
900# For Secure Boot The Image needs to be signed and Header must also
901# be included. So The image has to be built explicitly
e6385c7e 902INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
89ad7be8 903endif
467a40df 904endif
e6385c7e 905INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
d714a75f 906ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
e6385c7e 907INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
d21bd69b 908else
d714a75f 909ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
e6385c7e 910INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
0004b7aa 911else
e6385c7e 912INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
d21bd69b 913endif
0004b7aa 914endif
e6385c7e
SG
915INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
916INPUTS-$(CONFIG_OF_SEPARATE) += u-boot.dtb
2405d09c 917ifeq ($(CONFIG_SPL_FRAMEWORK),y)
e6385c7e 918INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
2405d09c 919endif
e6385c7e 920INPUTS-$(CONFIG_OF_HOSTFILE) += u-boot.dtb
b343bbb5 921ifneq ($(CONFIG_SPL_TARGET),)
e6385c7e 922INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
b343bbb5 923endif
e6385c7e
SG
924INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
925INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
926INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
0d3c62e4 927
e999bea4
SG
928# Generate this input file for binman
929ifeq ($(CONFIG_SPL),)
e6385c7e 930INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
e999bea4 931endif
3b975a14 932
b2b8a696
SR
933# Add optional build target if defined in board/cpu/soc headers
934ifneq ($(CONFIG_BUILD_TARGET),)
e6385c7e 935INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
b2b8a696
SR
936endif
937
dde1b75e 938ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
e6385c7e 939INPUTS-y += init_sp_bss_offset_check
5fed97af
SW
940endif
941
96699f09 942ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
e6385c7e 943INPUTS-y += u-boot-with-dtb.bin
96699f09
JG
944endif
945
e999bea4
SG
946ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
947# On ARM64 this target is produced by binman so we don't need this dep
948ifeq ($(CONFIG_ARM64),y)
949ifeq ($(CONFIG_SPL),y)
950# TODO: Get binman to generate this too
e6385c7e 951INPUTS-y += u-boot-rockchip.bin
1b0a936b 952endif
e999bea4
SG
953else
954ifeq ($(CONFIG_SPL),y)
955# Generate these inputs for binman which will create the output files
956INPUTS-y += idbloader.img u-boot.img
957endif
958endif
959endif
1b0a936b 960
42b18df8
SG
961INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
962 $(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
963 $(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
964
ad0fed46 965LDFLAGS_u-boot += $(LDFLAGS_FINAL)
e391b1e6
JS
966
967# Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
968LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
969
1022807c 970ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
433b2f1e
MY
971LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
972endif
71f84ef0 973
5972ff07
TR
974# insure the checker run with the right endianness
975CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
976
977# the checker needs the correct machine size
978CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
979
e020c88a 980# Normally we fill empty space with 0xff
f9c235fd 981quiet_cmd_objcopy = OBJCOPY $@
e020c88a
SG
982cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
983 $(OBJCOPYFLAGS_$(@F)) $< $@
984
985# Provide a version which does not do this, for use by EFI
986quiet_cmd_zobjcopy = OBJCOPY $@
987cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
f9c235fd 988
476476e7
SG
989quiet_cmd_efipayload = OBJCOPY $@
990cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
991
1f6a6648
SE
992MKIMAGEOUTPUT ?= /dev/null
993
b97241b3 994quiet_cmd_mkimage = MKIMAGE $@
9bf215b0 995cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
06587617 996 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
9bf215b0 997
1a12fdc4 998quiet_cmd_mkfitimage = MKIMAGE $@
18e08132
SG
999cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
1000 -f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
06587617 1001 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1a12fdc4 1002
ee0acfa2
MY
1003quiet_cmd_cat = CAT $@
1004cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1005
982a1199
MY
1006append = cat $(filter-out $< $(PHONY), $^) >> $@
1007
1008quiet_cmd_pad_cat = CAT $@
4532bf41 1009cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
982a1199 1010
a38f84b4
WG
1011quiet_cmd_lzma = LZMA $@
1012cmd_lzma = lzma -c -z -k -9 $< > $@
1013
1bd87630
SG
1014cfg: u-boot.cfg
1015
1bdd942b
MY
1016quiet_cmd_cfgcheck = CFGCHK $2
1017cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1018 $(srctree)/scripts/config_whitelist.txt $(srctree)
1019
e6385c7e
SG
1020PHONY += inputs
1021inputs: $(INPUTS-y)
1022
42b18df8
SG
1023all: .binman_stamp inputs
1024ifeq ($(CONFIG_BINMAN),y)
1025 $(call if_changed,binman)
1026endif
1027
1028# Timestamp file to make sure that binman always runs
1029.binman_stamp: FORCE
1030 @touch $@
e6385c7e 1031
63235bd0
JT
1032ifeq ($(CONFIG_DEPRECATED),y)
1033 $(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
bb85afc7
JT
1034ifeq ($(CONFIG_SPI),y)
1035ifneq ($(CONFIG_DM_SPI)$(CONFIG_OF_CONTROL),yy)
1036 $(warning "The relevant config item with associated code will remove in v2019.07 release.")
1037endif
1038endif
63235bd0 1039endif
282ed24f
HS
1040ifneq ($(CONFIG_DM),y)
1041 @echo >&2 "===================== WARNING ======================"
1042 @echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1043 @echo >&2 "compulsory starting with the v2020.01 release."
1044 @echo >&2 "Failure to update may result in board removal."
1045 @echo >&2 "See doc/driver-model/migration.rst for more info."
1046 @echo >&2 "===================================================="
1047endif
1cb5d5df 1048ifeq ($(CONFIG_MMC),y)
f992af81 1049ifneq ($(CONFIG_DM_MMC)$(CONFIG_BLK),yy)
a267699b
CP
1050 @echo >&2 "===================== WARNING ======================"
1051 @echo >&2 "This board does not use CONFIG_DM_MMC. Please update"
1052 @echo >&2 "the board to use CONFIG_DM_MMC before the v2019.04 release."
1053 @echo >&2 "Failure to update by the deadline may result in board removal."
a98f914e 1054 @echo >&2 "See doc/driver-model/migration.rst for more info."
a267699b 1055 @echo >&2 "===================================================="
109d8bf3
TR
1056endif
1057endif
1058ifeq ($(CONFIG_USB),y)
1059ifneq ($(CONFIG_DM_USB)$(CONFIG_OF_CONTROL)$(CONFIG_BLK),yyy)
a267699b
CP
1060 @echo >&2 "===================== WARNING ======================"
1061 @echo >&2 "This board does not use CONFIG_DM_USB. Please update"
1062 @echo >&2 "the board to use CONFIG_DM_USB before the v2019.07 release."
1063 @echo >&2 "Failure to update by the deadline may result in board removal."
a98f914e 1064 @echo >&2 "See doc/driver-model/migration.rst for more info."
a267699b 1065 @echo >&2 "===================================================="
1cb5d5df 1066endif
ea9d7c17 1067endif
29a6fa77 1068ifeq ($(CONFIG_MVSATA_IDE),y)
a267699b 1069 @echo >&2 "===================== WARNING ======================"
29a6fa77
SR
1070 @echo >&2 "This board does use CONFIG_MVSATA_IDE which is not"
1071 @echo >&2 "ported to driver-model (DM) yet. Please update the storage"
1072 @echo >&2 "controller driver to use CONFIG_AHCI before the v2019.07"
1073 @echo >&2 "release."
1074 @echo >&2 "Failure to update by the deadline may result in board removal."
a98f914e 1075 @echo >&2 "See doc/driver-model/migration.rst for more info."
29a6fa77
SR
1076 @echo >&2 "===================================================="
1077endif
1078ifeq ($(CONFIG_LIBATA),y)
1079ifneq ($(CONFIG_AHCI),y)
1080 @echo >&2 "===================== WARNING ======================"
1081 @echo >&2 "This board does use CONFIG_LIBATA but has CONFIG_AHCI not"
1082 @echo >&2 "enabled. Please update the storage controller driver to use"
1083 @echo >&2 "CONFIG_AHCI before the v2019.07 release."
a267699b 1084 @echo >&2 "Failure to update by the deadline may result in board removal."
a98f914e 1085 @echo >&2 "See doc/driver-model/migration.rst for more info."
a267699b 1086 @echo >&2 "===================================================="
841d5fba 1087endif
ddfe346f 1088endif
1ce689d9
SG
1089ifeq ($(CONFIG_PCI),y)
1090ifneq ($(CONFIG_DM_PCI),y)
1091 @echo >&2 "===================== WARNING ======================"
1092 @echo >&2 "This board does not use CONFIG_DM_PCI Please update"
1093 @echo >&2 "the board to use CONFIG_DM_PCI before the v2019.07 release."
1094 @echo >&2 "Failure to update by the deadline may result in board removal."
a98f914e 1095 @echo >&2 "See doc/driver-model/migration.rst for more info."
1ce689d9
SG
1096 @echo >&2 "===================================================="
1097endif
1098endif
3e87ffcf
SG
1099ifneq ($(CONFIG_LCD)$(CONFIG_VIDEO),)
1100ifneq ($(CONFIG_DM_VIDEO),y)
1101 @echo >&2 "===================== WARNING ======================"
1102 @echo >&2 "This board does not use CONFIG_DM_VIDEO Please update"
1103 @echo >&2 "the board to use CONFIG_DM_VIDEO before the v2019.07 release."
1104 @echo >&2 "Failure to update by the deadline may result in board removal."
a98f914e 1105 @echo >&2 "See doc/driver-model/migration.rst for more info."
3e87ffcf
SG
1106 @echo >&2 "===================================================="
1107endif
1108endif
841d5fba 1109ifeq ($(CONFIG_OF_EMBED),y)
a267699b
CP
1110 @echo >&2 "===================== WARNING ======================"
1111 @echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1112 @echo >&2 "be used for debugging purposes. Please use"
1113 @echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1114 @echo >&2 "See doc/README.fdt-control for more info."
1115 @echo >&2 "===================================================="
99a17dd5 1116endif
68979524
JT
1117ifeq ($(CONFIG_SPI_FLASH),y)
1118ifneq ($(CONFIG_DM_SPI_FLASH)$(CONFIG_OF_CONTROL),yy)
1119 @echo >&2 "===================== WARNING ======================"
1120 @echo >&2 "This board does not use CONFIG_DM_SPI_FLASH. Please update"
1121 @echo >&2 "the board to use CONFIG_SPI_FLASH before the v2019.07 release."
1122 @echo >&2 "Failure to update by the deadline may result in board removal."
a98f914e 1123 @echo >&2 "See doc/driver-model/migration.rst for more info."
68979524 1124 @echo >&2 "===================================================="
99a17dd5 1125endif
80af0fed
SR
1126endif
1127ifneq ($(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG),)
1128ifneq ($(CONFIG_WDT),y)
1129 @echo >&2 "===================== WARNING ======================"
1130 @echo >&2 "This board does not use CONFIG_WDT (DM watchdog support)."
1131 @echo >&2 "Please update the board to use CONFIG_WDT before the"
1132 @echo >&2 "v2019.10 release."
1133 @echo >&2 "Failure to update by the deadline may result in board removal."
a98f914e 1134 @echo >&2 "See doc/driver-model/migration.rst for more info."
80af0fed
SR
1135 @echo >&2 "===================================================="
1136endif
2e0f3241
HS
1137endif
1138ifneq ($(CONFIG_NET),)
1139ifneq ($(CONFIG_DM_ETH),y)
1140 @echo >&2 "===================== WARNING ======================"
1141 @echo >&2 "This board does not use CONFIG_DM_ETH (Driver Model"
1142 @echo >&2 "for Ethernet drivers). Please update the board to use"
1143 @echo >&2 "CONFIG_DM_ETH before the v2020.07 release. Failure to"
1144 @echo >&2 "update by the deadline may result in board removal."
1145 @echo >&2 "See doc/driver-model/migration.rst for more info."
1146 @echo >&2 "===================================================="
1147endif
f4a43d29
SG
1148endif
1149ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1150 @echo >&2 "===================== WARNING ======================"
1151 @echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1152 @echo >&2 "to binman instead, to avoid the proliferation of"
1153 @echo >&2 "arch-specific scripts with no tests."
1154 @echo >&2 "===================================================="
73845350 1155endif
4bf06d11
MY
1156 @# Check that this build does not use CONFIG options that we do not
1157 @# know about unless they are in Kconfig. All the existing CONFIG
1158 @# options are whitelisted, so new ones should not be added.
1bdd942b 1159 $(call cmd,cfgcheck,u-boot.cfg)
7ebf7443 1160
6ab6b2af 1161PHONY += dtbs
4141e85b
MY
1162dtbs: dts/dt.dtb
1163 @:
36dd5f1b 1164dts/dt.dtb: u-boot
6ab6b2af 1165 $(Q)$(MAKE) $(build)=dts dtbs
2c0f79e4 1166
ad1ecd20
SG
1167quiet_cmd_copy = COPY $@
1168 cmd_copy = cp $< $@
1169
11955590 1170ifeq ($(CONFIG_MULTI_DTB_FIT),y)
6f59fb07 1171
95f4bbd5
MV
1172ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1173FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1174else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1175FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1176else
1177FINAL_DTB_CONTAINER = fit-dtb.blob
1178endif
1179
1180fit-dtb.blob.gz: fit-dtb.blob
1181 @gzip -kf9 $< > $@
1182
1183fit-dtb.blob.lzo: fit-dtb.blob
1184 @lzop -f9 $< > $@
1185
6f59fb07
CJF
1186fit-dtb.blob: dts/dt.dtb FORCE
1187 $(call if_changed,mkimage)
878e2a50
VC
1188ifneq ($(SOURCE_DATE_EPOCH),)
1189 touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1190 chmod 0600 fit-dtb.blob
1191endif
6f59fb07
CJF
1192
1193MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1194 -a 0 -e 0 -E \
1195 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1196
c8c5e2b8
MS
1197ifneq ($(EXT_DTB),)
1198u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1199 $(call if_changed,cat)
1200else
748198cb 1201u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
6f59fb07 1202 $(call if_changed,cat)
c8c5e2b8 1203endif
6f59fb07
CJF
1204
1205u-boot.bin: u-boot-fit-dtb.bin FORCE
1206 $(call if_changed,copy)
16c776d3
HS
1207
1208u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1209 $(call if_changed,cat)
1210
6f59fb07 1211else ifeq ($(CONFIG_OF_SEPARATE),y)
ad1ecd20 1212u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
ee0acfa2 1213 $(call if_changed,cat)
2c0f79e4 1214
ad1ecd20
SG
1215u-boot.bin: u-boot-dtb.bin FORCE
1216 $(call if_changed,copy)
1217else
1218u-boot.bin: u-boot-nodtb.bin FORCE
1219 $(call if_changed,copy)
1220endif
1221
0f282c18
HS
1222# we call Makefile in arch/arm/mach-imx which
1223# has targets which are dependent on targets defined
1224# here. make could not resolve them and we must ensure
1225# that they are finished before calling imx targets
1226ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1227IMX_DEPS = u-boot-fit-dtb.bin
1228endif
1229
1230%.imx: $(IMX_DEPS) %.bin
552a848e 1231 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
219dee7e 1232 $(BOARD_SIZE_CHECK)
e64348f5 1233
ed0c2c0a
AA
1234%.vyb: %.imx
1235 $(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1236
1237quiet_cmd_copy = COPY $@
1238 cmd_copy = cp $< $@
1239
0d1e8aac
MY
1240u-boot.dtb: dts/dt.dtb
1241 $(call cmd,copy)
1242
f9c235fd 1243OBJCOPYFLAGS_u-boot.hex := -O ihex
6310eb9d 1244
f9c235fd 1245OBJCOPYFLAGS_u-boot.srec := -O srec
7ebf7443 1246
f9c235fd
MY
1247u-boot.hex u-boot.srec: u-boot FORCE
1248 $(call if_changed,objcopy)
1249
341ca905
MN
1250OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1251
1252u-boot-elf.srec: u-boot.elf FORCE
1253 $(call if_changed,objcopy)
1254
3ee58ea4
MV
1255OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1256
1257spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1258 $(call if_changed,objcopy)
1259
5602330d
MV
1260%.scif: %.srec
1261 $(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1262
ad1ecd20 1263OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
96699f09
JG
1264 $(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1265 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),-R .bootpg -R .resetvec)
f9c235fd 1266
ad1ecd20
SG
1267binary_size_check: u-boot-nodtb.bin FORCE
1268 @file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
3ce7a4fe 1269 map_size=$(shell cat u-boot.map | \
0b308f14 1270 awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
3ce7a4fe 1271 | sed 's/0X//g' \
0b308f14 1272 | bc); \
89742924
SG
1273 if [ "" != "$$map_size" ]; then \
1274 if test $$map_size -ne $$file_size; then \
3ce7a4fe 1275 echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
ad1ecd20 1276 echo " but u-boot-nodtb.bin shows $$file_size" >&2 ; \
89742924
SG
1277 exit 1; \
1278 fi \
1279 fi
1280
dde1b75e 1281ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
5fed97af
SW
1282ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1283subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1284else
1285subtract_sys_malloc_f_len = true
1286endif
1287# The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1288# so low that the DTB could probably use 90%+ of the available space, for
1289# current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1290# safe for now and tweak this later if space becomes tight.
1291# A rejected alternative would be to check that some absolute minimum stack
1292# space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1293# deliberately build-specific, to take account of build-to-build stack usage
1294# differences due to different feature sets, there is no common absolute value
1295# to check against.
1296init_sp_bss_offset_check: u-boot.dtb FORCE
1297 @dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1298 space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1299 $(subtract_sys_malloc_f_len) ; \
1300 quarter_space=$$(($${space} / 4)) ; \
1301 if [ $${dtb_size} -gt $${quarter_space} ]; then \
1302 echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1303 echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1304 exit 1 ; \
1305 fi
1306endif
1307
71d3fa7e 1308shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
ae897022
T
1309
1310quiet_cmd_objcopy_uboot = OBJCOPY $@
e9ebc17e 1311ifdef cmd_static_rela
4532bf41 1312cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
e9ebc17e
T
1313else
1314cmd_objcopy_uboot = $(cmd_objcopy)
1315endif
ae897022 1316
ad1ecd20 1317u-boot-nodtb.bin: u-boot FORCE
ae897022 1318 $(call if_changed,objcopy_uboot)
f9c235fd 1319 $(BOARD_SIZE_CHECK)
7ebf7443 1320
9e414032 1321u-boot.ldr: u-boot
76d82187 1322 $(CREATE_LDR_ENV)
240182d5 1323 $(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
f3a14d37 1324 $(BOARD_SIZE_CHECK)
94a91e24 1325
17a944b6
SG
1326# binman
1327# ---------------------------------------------------------------------------
a3c00550 1328# Use 'make BINMAN_DEBUG=1' to enable debugging
ef108047 1329# Use 'make BINMAN_VERBOSE=3' to set vebosity level
c0f1ebe9 1330default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
17a944b6 1331quiet_cmd_binman = BINMAN $@
4f4fb85e 1332cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
8fce3f29 1333 --toolpath $(objtree)/tools \
1f338e00 1334 $(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
bd4d0dcb 1335 build -u -d u-boot.dtb -O . -m --allow-missing \
a3c00550 1336 -I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
cfa3db60
SG
1337 -I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1338 -a atf-bl31-path=${BL31} \
c0f1ebe9 1339 -a default-dt=$(default_dt) \
18bd4559 1340 -a scp-path=$(SCP) \
4f4fb85e 1341 $(BINMAN_$(@F))
17a944b6 1342
f9c235fd
MY
1343OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1344
1345OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
94a91e24 1346
f9c235fd
MY
1347u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1348 $(call if_changed,objcopy)
94a91e24 1349
b40bda6b
SR
1350#
1351# U-Boot entry point, needed for booting of full-blown U-Boot
1352# from the SPL U-Boot version.
1353#
1354ifndef CONFIG_SYS_UBOOT_START
38a6cce6 1355CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
b40bda6b
SR
1356endif
1357
fc8db754 1358# Boards with more complex image requirements can provide an .its source file
1a12fdc4 1359# or a generator script
f4a43d29
SG
1360# NOTE: Please do not use this. We are migrating away from Makefile rules to use
1361# binman instead.
1a12fdc4 1362ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
0015e6de
PD
1363U_BOOT_ITS := u-boot.its
1364$(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1365 $(call if_changed,copy)
1a12fdc4 1366else
a8f3ace3 1367ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1a12fdc4 1368U_BOOT_ITS := u-boot.its
e3bc7c66
CS
1369ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-imx/mkimage_fit_atf.sh")
1370U_BOOT_ITS_DEPS += u-boot-nodtb.bin
1371endif
c29c1e61
AF
1372ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1373U_BOOT_ITS_DEPS += u-boot
1374endif
1375$(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1a12fdc4
AP
1376 $(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1377 $(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1378endif
1379endif
1380
cdf17246
SG
1381ifdef CONFIG_SPL_LOAD_FIT
1382MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1383 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
80cc9514 1384 -p $(CONFIG_FIT_EXTERNAL_OFFSET) \
cdf17246 1385 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
4e040b4d 1386 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
557bc97f
JJH
1387 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1388 $(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
cdf17246 1389else
9bf215b0
MY
1390MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1391 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1392 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
d21bd69b
SE
1393MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1394 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1395 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1f6a6648 1396u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
cdf17246 1397endif
bdccc4fe 1398
dae6e7bf
SG
1399MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1400
6cdd177c
BM
1401# Some boards have the kwbimage.cfg file written in advance, while some
1402# other boards generate it on the fly during the build in the build tree.
1403# Let's check if the file exists in the build tree first, otherwise we
1404# fall back to use the one in the source tree.
1405KWD_CONFIG_FILE = $(shell \
1406 if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1407 echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1408 else \
1409 echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1410 fi)
1411
1412MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
4ab3fc5e 1413 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
8edcde5e 1414
6cdd177c 1415MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
a1b6b0a9
MS
1416 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1417 $(if $(KEYDIR),-k $(KEYDIR))
a90ffb56 1418
e4536f8e
MY
1419MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1420 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage
aa0c7a86 1421
bcda5b0d
HZ
1422ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1423UBOOT_BIN := u-boot-with-dtb.bin
1424else
1425UBOOT_BIN := u-boot.bin
1426endif
1427
a38f84b4
WG
1428MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1429 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1430 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1431
1432u-boot.bin.lzma: u-boot.bin FORCE
1433 $(call if_changed,lzma)
1434
1435u-boot-lzma.img: u-boot.bin.lzma FORCE
1436 $(call if_changed,mkimage)
1437
d21bd69b 1438u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
2c768613
LA
1439 $(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1440 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_OF_HOSTFILE),dts/dt.dtb) \
e4b8dd9b 1441 ,$(UBOOT_BIN)) FORCE
9bf215b0 1442 $(call if_changed,mkimage)
45297e2a 1443 $(BOARD_SIZE_CHECK)
9bf215b0 1444
7a778369
MV
1445ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1446MKIMAGEFLAGS_u-boot.itb =
1447else
1448MKIMAGEFLAGS_u-boot.itb = -E
1449endif
1450
509978e5 1451ifdef U_BOOT_ITS
2c768613
LA
1452u-boot.itb: u-boot-nodtb.bin \
1453 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_OF_HOSTFILE),dts/dt.dtb) \
1454 $(U_BOOT_ITS) FORCE
1a12fdc4 1455 $(call if_changed,mkfitimage)
e89f5591 1456 $(BOARD_SIZE_CHECK)
509978e5 1457endif
1a12fdc4 1458
73c5c399 1459u-boot-spl.kwb: u-boot.img spl/u-boot-spl.bin FORCE
a90ffb56
SR
1460 $(call if_changed,mkimage)
1461
9e414032
MY
1462u-boot.sha1: u-boot.bin
1463 tools/ubsha1 u-boot.bin
566a494f 1464
9e414032 1465u-boot.dis: u-boot
7ebf7443
WD
1466 $(OBJDUMP) -d $< > $@
1467
7550dbe3
YS
1468ifneq ($(CONFIG_SPL_PAYLOAD),)
1469SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
3aa29de0 1470else
9e414032 1471SPL_PAYLOAD := u-boot.bin
3aa29de0 1472endif
74752baa 1473
9ea6f718
SR
1474SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1475
982a1199
MY
1476OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1477 --pad-to=$(CONFIG_SPL_PAD_TO)
9ea6f718 1478u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
982a1199 1479 $(call if_changed,pad_cat)
3aa29de0 1480
1b0a936b 1481ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
b1022d5f 1482
66ffe317
JT
1483# TPL + SPL
1484ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
f6f9affd 1485MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
3029a7bb 1486tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1b0a936b 1487 $(call if_changed,mkimage)
3029a7bb 1488idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1b0a936b 1489 $(call if_changed,cat)
66ffe317 1490else
f6f9affd 1491MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
66ffe317
JT
1492idbloader.img: spl/u-boot-spl.bin FORCE
1493 $(call if_changed,mkimage)
1b0a936b
MK
1494endif
1495
e999bea4 1496ifeq ($(CONFIG_ARM64),y)
79030a48
JT
1497OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
1498 --pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
1499u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
1500 $(call if_changed,pad_cat)
1501endif # CONFIG_ARM64
1502
1503endif # CONFIG_ARCH_ROCKCHIP
1b0a936b 1504
e3e0819c 1505ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
412ae53a
AA
1506MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1507
1508lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1509 $(call if_changed,mkimage)
1510
1511OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1512
514ec438 1513lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
412ae53a
AA
1514 $(call if_changed,objcopy)
1515
1516OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1517
514ec438 1518lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
412ae53a
AA
1519 $(call if_changed,objcopy)
1520
514ec438 1521lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
412ae53a
AA
1522 $(call if_changed,cat)
1523
e3e0819c 1524endif
412ae53a 1525
982a1199
MY
1526OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1527 --pad-to=$(CONFIG_TPL_PAD_TO)
1528tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1529 $(call if_changed,pad_cat)
7816f2cf 1530
630d2345 1531SPL: spl/u-boot-spl.bin FORCE
552a848e 1532 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
630d2345 1533
caceb739 1534ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
700315c9
PF
1535ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1536u-boot.cnt: u-boot.bin FORCE
1537 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1538
1539flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1540 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1541else
94df9885
PF
1542flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1543 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1544endif
700315c9 1545endif
94df9885 1546
7034478a
MV
1547u-boot.uim: u-boot.bin FORCE
1548 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1549
1550u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
552a848e 1551 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
7d5a5c79 1552
9bf215b0
MY
1553MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1554
1555u-boot.ubl: u-boot-with-spl.bin FORCE
1556 $(call if_changed,mkimage)
277f00f5 1557
982a1199
MY
1558MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1559 $(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1560 -T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1561spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1562 $(call if_changed,mkimage)
d36d8859 1563
532d5318 1564OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
982a1199
MY
1565u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1566 $(call if_changed,pad_cat)
a5453555 1567
1a9df13d
MV
1568u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1569 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
03c7b3fc 1570u-boot.sb: u-boot.bin spl/u-boot-spl.bin
07e27ce0 1571 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
30b9b932 1572
94aebe6c
SR
1573# On x600 (SPEAr600) U-Boot is appended to U-Boot SPL.
1574# Both images are created using mkimage (crc etc), so that the ROM
1575# bootloader can check its integrity. Padding needs to be done to the
1576# SPL image (with mkimage header) and not the binary. Otherwise the resulting image
1577# which is loaded/copied by the ROM bootloader to SRAM doesn't fit.
1578# The resulting image containing both U-Boot images is called u-boot.spr
982a1199
MY
1579MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1580 -a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1581spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1582 $(call if_changed,mkimage)
1583
1584OBJCOPYFLAGS_u-boot.spr = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1585 --gap-fill=0xff
1586u-boot.spr: spl/u-boot-spl.img u-boot.img FORCE
1587 $(call if_changed,pad_cat)
94aebe6c 1588
333b7209 1589ifneq ($(CONFIG_ARCH_SOCFPGA),)
505dc1c6 1590quiet_cmd_gensplx4 = GENSPLX4 $@
40551cf9
LFT
1591cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0 \
1592 --pad-to=$(CONFIG_SPL_PAD_TO) \
1593 spl/u-boot-spl.sfp spl/u-boot-spl.sfp && \
1594 cat spl/u-boot-spl.sfp spl/u-boot-spl.sfp \
4532bf41 1595 spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
505dc1c6
CHA
1596spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1597 $(call if_changed,gensplx4)
1598
333b7209 1599quiet_cmd_socboot = SOCBOOT $@
4532bf41 1600cmd_socboot = cat spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
505dc1c6 1601u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
333b7209 1602 $(call if_changed,socboot)
533832c6 1603
505dc1c6
CHA
1604quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1605cmd_gensplpadx4 = dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
533832c6
MV
1606 cat spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1607 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1608 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
505dc1c6 1609 spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
4532bf41 1610 { rm -f $@ spl/u-boot-spl.pad; false; }
505dc1c6
CHA
1611u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1612 $(call if_changed,gensplpadx4)
1613
1614quiet_cmd_socnandboot = SOCNANDBOOT $@
4532bf41 1615cmd_socnandboot = cat u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
505dc1c6 1616u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
533832c6
MV
1617 $(call if_changed,socnandboot)
1618
333b7209
MV
1619endif
1620
96699f09
JG
1621ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1622u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
1623 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
1624 $(call if_changed,binman)
1625
1626ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
1627OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1628u-boot-br.bin: u-boot FORCE
1629 $(call if_changed,objcopy)
1630endif
1631endif
1632
0adf8d35
SG
1633quiet_cmd_ldr = LD $@
1634cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1635 $(filter-out FORCE,$^) -o $@
1636
bcd4e6f3 1637ifdef CONFIG_X86
5e239183
SG
1638OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1639u-boot-x86-start16.bin: u-boot FORCE
1640 $(call if_changed,objcopy)
1641
1642OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1643u-boot-x86-reset16.bin: u-boot FORCE
fce7b276 1644 $(call if_changed,objcopy)
aafe5c5e 1645
42b18df8 1646endif # CONFIG_X86
bcd4e6f3 1647
08aeb8b5
SG
1648OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1649u-boot-app.efi: u-boot FORCE
1650 $(call if_changed,zobjcopy)
1651
73c5c399 1652u-boot.bin.o: u-boot.bin FORCE
476476e7
SG
1653 $(call if_changed,efipayload)
1654
1655u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1656 $(call if_changed_dep,cpp_lds)
1657
1658# Rule to link the EFI payload which contains a stub and a U-Boot binary
1659quiet_cmd_u-boot_payload ?= LD $@
1660 cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
96a8d409 1661 -T u-boot-payload.lds arch/x86/cpu/call32.o \
73c5c399 1662 lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
2dcd4e9e 1663 $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
476476e7 1664
73c5c399 1665u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
476476e7
SG
1666 $(call if_changed,u-boot_payload)
1667
1668OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1669u-boot-payload.efi: u-boot-payload FORCE
1670 $(call if_changed,zobjcopy)
1671
ee0acfa2
MY
1672u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1673 $(call if_changed,cat)
fb3d2b8a 1674
89ad7be8
PK
1675#Add a target to create boot binary having SPL binary in PBI format
1676#concatenated with u-boot binary. It is need by PowerPC SoC having
1677#internal SRAM <= 512KB.
1678MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
94cb17d0
AW
1679 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1680 -A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
89ad7be8
PK
1681
1682spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1683 $(call if_changed,mkimage)
1684
45c2e480
AW
1685ifeq ($(ARCH),arm)
1686UBOOT_BINLOAD := u-boot.img
1687else
96699f09
JG
1688ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1689UBOOT_BINLOAD := u-boot-with-dtb.bin
1690else
45c2e480
AW
1691UBOOT_BINLOAD := u-boot.bin
1692endif
96699f09 1693endif
45c2e480 1694
89ad7be8
PK
1695OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1696 --gap-fill=0xff
1697
45c2e480 1698u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
89ad7be8
PK
1699 $(call if_changed,pad_cat)
1700
ecddccd0
SR
1701# PPC4xx needs the SPL at the end of the image, since the reset vector
1702# is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1703# and need to introduce a new build target with the full blown U-Boot
1704# at the start padded up to the start of the SPL image. And then concat
1705# the SPL image to the end.
982a1199
MY
1706
1707OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1708 --pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1709u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1710 $(call if_changed,pad_cat)
ecddccd0 1711
e69945ee
ÁFR
1712quiet_cmd_u-boot-elf ?= LD $@
1713 cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
e14ba8a5 1714 -T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
e69945ee 1715 -Ttext=$(CONFIG_SYS_TEXT_BASE)
e14ba8a5 1716u-boot.elf: u-boot.bin u-boot-elf.lds
e69945ee
ÁFR
1717 $(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1718 $(call if_changed,u-boot-elf)
f4dc714a 1719
e14ba8a5
MS
1720u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1721 $(call if_changed_dep,cpp_lds)
1722
3b975a14
RL
1723# MediaTek's ARM-based u-boot needs a header to contains its load address
1724# which is parsed by the BootROM.
1725# If the SPL build is enabled, the header will be added to the spl binary,
1726# and the spl binary and the u-boot.img will be combined into one file.
1727# Otherwise the header will be added to the u-boot.bin directly.
1728
1729ifeq ($(CONFIG_SPL),y)
1730spl/u-boot-spl-mtk.bin: spl/u-boot-spl
3b975a14
RL
1731else
1732MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1733 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1734 -n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1735
1736u-boot-mtk.bin: u-boot.bin FORCE
1737 $(call if_changed,mkimage)
1738endif
1739
b8cecd0c
DS
1740quiet_cmd_endian_swap = SWAP $@
1741 cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1742
1743u-boot-swap.bin: u-boot.bin FORCE
1744 $(call if_changed,endian_swap)
1745
09bebb83
PB
1746ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1747
ad0fed46
MY
1748# Rule to link u-boot
1749# May be overridden by arch/$(ARCH)/config.mk
1750quiet_cmd_u-boot__ ?= LD $@
587e4a42 1751 cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
ad0fed46
MY
1752 -T u-boot.lds $(u-boot-init) \
1753 --start-group $(u-boot-main) --end-group \
09bebb83
PB
1754 $(PLATFORM_LIBS) -Map u-boot.map; \
1755 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
86eb49b3 1756
cac8f38a
VG
1757quiet_cmd_smap = GEN common/system_map.o
1758cmd_smap = \
ad0fed46
MY
1759 smap=`$(call SYSTEM_MAP,u-boot) | \
1760 awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1761 $(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1762 -c $(srctree)/common/system_map.c -o common/system_map.o
cac8f38a 1763
514ec438 1764u-boot: $(u-boot-init) $(u-boot-main) u-boot.lds FORCE
09bebb83 1765 +$(call if_changed,u-boot__)
cac8f38a
VG
1766ifeq ($(CONFIG_KALLSYMS),y)
1767 $(call cmd,smap)
ad0fed46 1768 $(call cmd,u-boot__) common/system_map.o
ecb1dc89 1769endif
7ebf7443 1770
42ac26f2
RC
1771ifeq ($(CONFIG_RISCV),y)
1772 @tools/prelink-riscv $@ 0
1773endif
1774
7ed4848b
SW
1775quiet_cmd_sym ?= SYM $@
1776 cmd_sym ?= $(OBJDUMP) -t $< > $@
1777u-boot.sym: u-boot FORCE
1778 $(call if_changed,sym)
1779
69c0d323 1780# The actual objects are generated when descending,
656de6b8
MY
1781# make sure no implicit rule kicks in
1782$(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
f9328639 1783
32f2ca2a 1784# Handle descending into subdirectories listed in $(u-boot-dirs)
656de6b8
MY
1785# Preset locale variables to speed up the build process. Limit locale
1786# tweaks to this spot to avoid wrong language settings when running
1787# make menuconfig etc.
1788# Error messages still appears in the original language
a8c7c708 1789
656de6b8 1790PHONY += $(u-boot-dirs)
6378008a 1791$(u-boot-dirs): prepare scripts
656de6b8
MY
1792 $(Q)$(MAKE) $(build)=$@
1793
7424145f 1794tools: prepare
656de6b8
MY
1795# The "tools" are needed early
1796$(filter-out tools, $(u-boot-dirs)): tools
1797# The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1798# is "yes"), so compile examples after U-Boot is compiled.
1799examples: $(filter-out examples, $(u-boot-dirs))
940db16d 1800
7424145f
MY
1801define filechk_uboot.release
1802 echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1803endef
1804
1805# Store (new) UBOOTRELEASE string in include/config/uboot.release
51148790 1806include/config/uboot.release: include/config/auto.conf FORCE
7424145f
MY
1807 $(call filechk,uboot.release)
1808
1809
3341bfec
MY
1810# Things we need to do before we recursively start building the kernel
1811# or the modules are listed in "prepare".
1812# A multi level approach is used. prepareN is processed before prepareN-1.
1813# archprepare is used in arch Makefiles and when processed asm symlink,
1814# version.h and scripts_basic is processed / created.
1815
1816# Listed in dependency order
1817PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1818
1819# prepare3 is used to check if we are building in a separate output directory,
1820# and if so do:
1821# 1) Check that make has not been executed in the kernel src $(srctree)
7424145f 1822prepare3: include/config/uboot.release
3341bfec 1823ifneq ($(KBUILD_SRC),)
51148790
MY
1824 @$(kecho) ' Using $(srctree) as source for U-Boot'
1825 $(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
3341bfec
MY
1826 echo >&2 " $(srctree) is not clean, please run 'make mrproper'"; \
1827 echo >&2 " in the '$(srctree)' directory.";\
1828 /bin/false; \
1829 fi;
ecb1dc89 1830endif
7ebf7443 1831
3341bfec 1832# prepare2 creates a makefile if using a separate output directory
0b588def 1833prepare2: prepare3 outputmakefile cfg
3341bfec 1834
dacec83c 1835prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) \
51148790 1836 include/config/auto.conf
4a377552
MY
1837ifeq ($(wildcard $(LDSCRIPT)),)
1838 @echo >&2 " Could not find linker script."
1839 @/bin/false
1840endif
f9328639 1841
f3d8f7dd
RV
1842ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1843prepare1: $(defaultenv_h)
1844endif
1845
3341bfec
MY
1846archprepare: prepare1 scripts_basic
1847
6a44d806
MY
1848prepare0: archprepare FORCE
1849 $(Q)$(MAKE) $(build)=.
a8c7c708 1850
3341bfec
MY
1851# All the preparing..
1852prepare: prepare0
7ebf7443 1853
7424145f
MY
1854# Generate some files
1855# ---------------------------------------------------------------------------
1856
68f6a90e 1857# Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
7424145f
MY
1858define filechk_version.h
1859 (echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1860 echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
68f6a90e
SG
1861 echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1862 echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1863 sed -e "s/^0*//"); \
42ffa51f
VC
1864 echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1865 echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
7424145f
MY
1866endef
1867
2d9efa12
AB
1868# The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1869# The BSD date on the other hand behaves different and would produce errors
1870# with the misused '-d' switch. Respect that and search a working date with
1871# well known pre- and suffixes for the GNU variant of date.
7424145f 1872define filechk_timestamp.h
70d39f57
CP
1873 (if test -n "$${SOURCE_DATE_EPOCH}"; then \
1874 SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
2d9efa12
AB
1875 DATE=""; \
1876 for date in gdate date.gnu date; do \
1877 $${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
1878 done; \
1879 if test -n "$${DATE}"; then \
1880 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
1881 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
1882 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
a34b4676 1883 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DMI_DATE "%m/%d/%Y"'; \
e7aa9c29 1884 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_BUILD_DATE 0x%Y%m%d'; \
cbf0ffea 1885 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
2d9efa12
AB
1886 else \
1887 return 42; \
1888 fi; \
70d39f57
CP
1889 else \
1890 LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
1891 LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
1892 LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
a34b4676 1893 LC_ALL=C date +'#define U_BOOT_DMI_DATE "%m/%d/%Y"'; \
e7aa9c29 1894 LC_ALL=C date +'#define U_BOOT_BUILD_DATE 0x%Y%m%d'; \
cbf0ffea 1895 LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
70d39f57 1896 fi)
7424145f
MY
1897endef
1898
f3d8f7dd
RV
1899define filechk_defaultenv.h
1900 (grep -v '^#' | \
1901 grep -v '^$$' | \
1902 tr '\n' '\0' | \
4b7f5f3e 1903 sed -e 's/\\\x0\s*//g' | \
f3d8f7dd
RV
1904 xxd -i ; echo ", 0x00" ; )
1905endef
1906
dacec83c
MS
1907define filechk_dt.h
1908 (if test -n "$${DEVICE_TREE}"; then \
1909 echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
1910 else \
1911 echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
1912 fi)
1913endef
1914
2e6b2f6a 1915$(version_h): include/config/uboot.release FORCE
7424145f
MY
1916 $(call filechk,version.h)
1917
1918$(timestamp_h): $(srctree)/Makefile FORCE
1919 $(call filechk,timestamp.h)
1920
dacec83c
MS
1921$(dt_h): $(srctree)/Makefile FORCE
1922 $(call filechk,dt.h)
1923
f3d8f7dd
RV
1924$(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
1925 $(call filechk,defaultenv.h)
1926
6378008a 1927# ---------------------------------------------------------------------------
04a34c96 1928quiet_cmd_cpp_lds = LDS $@
de5e5cea 1929cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
44093a15 1930 -D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
6378008a 1931
04a34c96 1932u-boot.lds: $(LDSCRIPT) prepare FORCE
395e60cd 1933 $(call if_changed_dep,cpp_lds)
887e2ec9 1934
982a1199
MY
1935spl/u-boot-spl.bin: spl/u-boot-spl
1936 @:
0a0f2314
HS
1937 $(SPL_SIZE_CHECK)
1938
9773ebcf
DW
1939spl/u-boot-spl-dtb.bin: spl/u-boot-spl
1940 @:
1941
1942spl/u-boot-spl-dtb.hex: spl/u-boot-spl
1943 @:
1944
054b3a1e 1945spl/u-boot-spl: tools prepare \
dd2081a8
VB
1946 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb) \
1947 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_TPL_OF_PLATDATA),dts/dt.dtb)
c7163083 1948 $(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
5df2ee27 1949
50827a59
IC
1950spl/sunxi-spl.bin: spl/u-boot-spl
1951 @:
1952
d2fdcc76
MR
1953spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
1954 @:
1955
bd7dc388 1956spl/u-boot-spl.sfp: spl/u-boot-spl
333b7209
MV
1957 @:
1958
08598d6e
NR
1959spl/boot.bin: spl/u-boot-spl
1960 @:
1961
3c00a2c8 1962tpl/u-boot-tpl.bin: tools prepare \
dd2081a8 1963 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb)
51148790 1964 $(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
c52b5e8e 1965 $(TPL_SIZE_CHECK)
3aa29de0 1966
8d819ab5 1967TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
a340c325 1968
857d9ea6
HK
1969FIND := find
1970FINDFLAGS := -L
1971
f9328639 1972tags ctags:
9e414032 1973 ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
e5e4e705 1974 -name '*.[chS]' -print`
74d339be 1975 ln -s ctags tags
7ebf7443
WD
1976
1977etags:
8d819ab5 1978 etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
e5e4e705 1979 -name '*.[chS]' -print`
ffda586f 1980cscope:
857d9ea6
HK
1981 $(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
1982 cscope.files
e15a951d
AS
1983 @find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
1984 grep -xvf - cscope.files > cscope.files.no-symlinks; \
1985 mv cscope.files.no-symlinks cscope.files
ffda586f 1986 cscope -b -q -k
7ebf7443 1987
ecb1dc89
MF
1988SYSTEM_MAP = \
1989 $(NM) $1 | \
7ebf7443 1990 grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
ecb1dc89 1991 LC_ALL=C sort
9e414032 1992System.map: u-boot
bc8bb6ec 1993 @$(call SYSTEM_MAP,$<) > $@
7ebf7443
WD
1994
1995#########################################################################
7ebf7443 1996
54799e45
SW
1997# ARM relocations should all be R_ARM_RELATIVE (32-bit) or
1998# R_AARCH64_RELATIVE (64-bit).
9e414032 1999checkarmreloc: u-boot
54799e45
SW
2000 @RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
2001 grep R_A | sort -u`"; \
2002 if test "$$RELOC" != "R_ARM_RELATIVE" -a \
2003 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
2004 echo "$< contains unexpected relocations: $$RELOC"; \
2005 false; \
2006 fi
c37980c3 2007
4d90f6cd 2008tools/version.h: include/version.h
fb013eee 2009 $(Q)mkdir -p $(dir $@)
4d90f6cd
BM
2010 $(call if_changed,copy)
2011
2012envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2d3229be 2013 $(Q)$(MAKE) $(build)=tools/env
0358df42 2014
2577015d 2015tools-only: export TOOLS_ONLY=y
4d90f6cd 2016tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
4642e002
MY
2017 $(Q)$(MAKE) $(build)=tools
2018
1ec8b4ef 2019tools-all: export HOST_TOOLS_ALL=y
57332957 2020tools-all: envtools tools ;
0358df42 2021
db5b339c
MY
2022cross_tools: export CROSS_BUILD_TOOLS=y
2023cross_tools: tools ;
2024
4e53a258
WD
2025.PHONY : CHANGELOG
2026CHANGELOG:
b985b5d6
BW
2027 git log --no-merges U-Boot-1_1_5.. | \
2028 unexpand -a | sed -e 's/\s\s*$$//' > $@
4e53a258 2029
7ebf7443
WD
2030#########################################################################
2031
efcf8619
MY
2032###
2033# Cleaning is done on three levels.
2034# make clean Delete most generated files
2035# Leave enough to build external modules
2036# make mrproper Delete the current configuration, and all generated files
2037# make distclean Remove editor backup files, patch leftover files and the like
2038
2039# Directories & files removed with 'make clean'
48aa812d
MY
2040CLEAN_DIRS += $(MODVERDIR) \
2041 $(foreach d, spl tpl, $(patsubst %,$d/%, \
51148790 2042 $(filter-out include, $(shell ls -1 $d 2>/dev/null))))
48aa812d 2043
4d90f6cd 2044CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h tools/version.h \
57297e60
TH
2045 boot* u-boot* MLO* SPL System.map fit-dtb.blob* \
2046 u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
983c0f91 2047 lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
774904c9 2048 idbloader.img flash.bin flash.log defconfig
efcf8619
MY
2049
2050# Directories & files removed with 'make mrproper'
51148790 2051MRPROPER_DIRS += include/config include/generated spl tpl \
9a97314b 2052 .tmp_objdiff doc/output
51148790 2053MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
1249fa8f
HS
2054 ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2055 drivers/video/fonts/*.S
efcf8619
MY
2056
2057# clean - Delete most, but leave enough to build external modules
2058#
2059clean: rm-dirs := $(CLEAN_DIRS)
2060clean: rm-files := $(CLEAN_FILES)
2061
6bd04bb4 2062clean-dirs := $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
efcf8619 2063
08fcdd33 2064clean-dirs := $(addprefix _clean_, $(clean-dirs))
efcf8619
MY
2065
2066PHONY += $(clean-dirs) clean archclean
2067$(clean-dirs):
2068 $(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2069
efcf8619
MY
2070clean: $(clean-dirs)
2071 $(call cmd,rmdirs)
2072 $(call cmd,rmfiles)
2073 @find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2074 \( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
d4c51412 2075 -o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
efcf8619 2076 -o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
e91610da 2077 -o -name '*.lex.c' -o -name '*.tab.[ch]' \
ed3dead9 2078 -o -name '*.asn1.[ch]' \
efcf8619
MY
2079 -o -name '*.symtypes' -o -name 'modules.order' \
2080 -o -name modules.builtin -o -name '.tmp_*.o.*' \
0fbdaa0e 2081 -o -name 'dsdt.aml' -o -name 'dsdt.asl.tmp' -o -name 'dsdt.c' \
7f474ef6 2082 -o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
0f18cf32 2083 -type f -print | xargs rm -f
efcf8619 2084
efcf8619
MY
2085# mrproper - Delete all generated files, including .config
2086#
2087mrproper: rm-dirs := $(wildcard $(MRPROPER_DIRS))
2088mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2089mrproper-dirs := $(addprefix _mrproper_,scripts)
7ebf7443 2090
efcf8619
MY
2091PHONY += $(mrproper-dirs) mrproper archmrproper
2092$(mrproper-dirs):
2093 $(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2094
48aa812d 2095mrproper: clean $(mrproper-dirs)
efcf8619
MY
2096 $(call cmd,rmdirs)
2097 $(call cmd,rmfiles)
e9c16a80 2098 @rm -f arch/*/include/asm/arch
efcf8619
MY
2099
2100# distclean
2101#
2102PHONY += distclean
433b2f1e
MY
2103
2104distclean: mrproper
efcf8619
MY
2105 @find $(srctree) $(RCS_FIND_IGNORE) \
2106 \( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2107 -o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
598e2d33
MY
2108 -o -name '.*.rej' -o -name '*%' -o -name 'core' \
2109 -o -name '*.pyc' \) \
efcf8619 2110 -type f -print | xargs rm -f
c1180aa2 2111 @rm -f boards.cfg CHANGELOG
7ebf7443
WD
2112
2113backup:
4379ac61 2114 F=`basename $(srctree)` ; cd .. ; \
d6b93714 2115 gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
7ebf7443 2116
ed1ca528
MY
2117help:
2118 @echo 'Cleaning targets:'
48aa812d 2119 @echo ' clean - Remove most generated files but keep the config'
ed1ca528
MY
2120 @echo ' mrproper - Remove all generated files + config + various backup files'
2121 @echo ' distclean - mrproper + remove editor backup and patch files'
2122 @echo ''
51148790
MY
2123 @echo 'Configuration targets:'
2124 @$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2125 @echo ''
a3a3f5d5
SG
2126 @echo 'Test targets:'
2127 @echo ''
2128 @echo ' check - Run all automated tests that use sandbox'
499fde5c 2129 @echo ' qcheck - Run quick automated tests that use sandbox'
76160801 2130 @echo ' tcheck - Run quick automated tests on tools'
a3a3f5d5 2131 @echo ''
ed1ca528
MY
2132 @echo 'Other generic targets:'
2133 @echo ' all - Build all necessary images depending on configuration'
633cc7ae 2134 @echo ' tests - Build U-Boot for sandbox and run tests'
ffe29ebc 2135 @echo '* u-boot - Build the bare u-boot'
ed1ca528
MY
2136 @echo ' dir/ - Build all files in dir and below'
2137 @echo ' dir/file.[oisS] - Build specified target only'
2138 @echo ' dir/file.lst - Build specified mixed source/assembly target only'
2139 @echo ' (requires a recent binutils and recent build (System.map))'
5fc2f924
IG
2140 @echo ' tags/ctags - Generate ctags file for editors'
2141 @echo ' etags - Generate etags file for editors'
ed1ca528 2142 @echo ' cscope - Generate cscope index'
ffe29ebc
MY
2143 @echo ' ubootrelease - Output the release version string (use with make -s)'
2144 @echo ' ubootversion - Output the version stored in Makefile (use with make -s)'
1bd87630 2145 @echo " cfg - Don't build, just create the .cfg files"
84a42069 2146 @echo " envtools - Build only the target-side environment tools"
ed1ca528
MY
2147 @echo ''
2148 @echo 'Static analysers'
2149 @echo ' checkstack - Generate a list of stack hogs'
8a28caf0 2150 @echo ' coccicheck - Execute static code analysis with Coccinelle'
ed1ca528
MY
2151 @echo ''
2152 @echo 'Documentation targets:'
656d8da9 2153 @$(MAKE) -f $(srctree)/doc/Makefile dochelp
ed1ca528
MY
2154 @echo ''
2155 @echo ' make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2156 @echo ' make V=2 [targets] 2 => give reason for rebuild of target'
2157 @echo ' make O=dir [targets] Locate all output files in "dir", including .config'
2158 @echo ' make C=1 [targets] Check all c source with $$CHECK (sparse by default)'
2159 @echo ' make C=2 [targets] Force check of all c source with $$CHECK'
2160 @echo ' make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2161 @echo ' make W=n [targets] Enable extra gcc checks, n=1,2,3 where'
2162 @echo ' 1: warnings which may be relevant and do not occur too often'
2163 @echo ' 2: warnings which occur quite often but may still be relevant'
2164 @echo ' 3: more obscure warnings, can most likely be ignored'
2165 @echo ' Multiple levels can be combined with W=12 or W=123'
2166 @echo ''
2167 @echo 'Execute "make" or "make all" to build all targets marked with [*] '
2168 @echo 'For further info see the ./README file'
2169
a3a3f5d5 2170tests check:
633cc7ae 2171 $(srctree)/test/run
8fac9c7b 2172
499fde5c
SG
2173qcheck:
2174 $(srctree)/test/run quick
2175
76160801
SG
2176tcheck:
2177 $(srctree)/test/run tools
2178
8fac9c7b
MY
2179# Documentation targets
2180# ---------------------------------------------------------------------------
78a88f79
MS
2181DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2182 linkcheckdocs dochelp refcheckdocs
2183PHONY += $(DOC_TARGETS)
2184$(DOC_TARGETS): scripts_basic FORCE
656d8da9 2185 $(Q)$(MAKE) $(build)=doc $@
8fac9c7b 2186
433b2f1e
MY
2187endif #ifeq ($(config-targets),1)
2188endif #ifeq ($(mixed-targets),1)
2189
ed1ca528
MY
2190PHONY += checkstack ubootrelease ubootversion
2191
2192checkstack:
2193 $(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2194 $(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2195
2196ubootrelease:
2197 @echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2198
2199ubootversion:
2200 @echo $(UBOOTVERSION)
2201
886d86e8
MY
2202# Single targets
2203# ---------------------------------------------------------------------------
2204# Single targets are compatible with:
2205# - build with mixed source and output
2206# - build with separate output dir 'make O=...'
2207# - external modules
2208#
2209# target-dir => where to store outputfile
2210# build-dir => directory in kernel source tree to use
2211
2212ifeq ($(KBUILD_EXTMOD),)
2213 build-dir = $(patsubst %/,%,$(dir $@))
2214 target-dir = $(dir $@)
2215else
2216 zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2217 build-dir = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2218 target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2219endif
2220
2221%.s: %.c prepare scripts FORCE
2222 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2223%.i: %.c prepare scripts FORCE
2224 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2225%.o: %.c prepare scripts FORCE
2226 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2227%.lst: %.c prepare scripts FORCE
2228 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2229%.s: %.S prepare scripts FORCE
2230 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2231%.o: %.S prepare scripts FORCE
2232 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2233%.symtypes: %.c prepare scripts FORCE
2234 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2235
2236# Modules
2237/: prepare scripts FORCE
2238 $(cmd_crmodverdir)
2239 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2240 $(build)=$(build-dir)
2241%/: prepare scripts FORCE
2242 $(cmd_crmodverdir)
2243 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2244 $(build)=$(build-dir)
2245%.ko: prepare scripts FORCE
2246 $(cmd_crmodverdir)
2247 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2248 $(build)=$(build-dir) $(@:.ko=.o)
2249 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2250
bdaa73a5
SB
2251quiet_cmd_genenv = GENENV $@
2252cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2253 sed --in-place -e 's/\x00/\x0A/g' $@
2254
2255u-boot-initial-env: u-boot.bin
2256 $(call if_changed,genenv)
2257
8a28caf0
HS
2258# Consistency checks
2259# ---------------------------------------------------------------------------
2260
2261PHONY += coccicheck
2262
2263coccicheck:
2264 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2265
69c0d323 2266# FIXME Should go into a make.lib or something
886d86e8
MY
2267# ===========================================================================
2268
efcf8619
MY
2269quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN $(wildcard $(rm-dirs)))
2270 cmd_rmdirs = rm -rf $(rm-dirs)
2271
2272quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN $(wildcard $(rm-files)))
2273 cmd_rmfiles = rm -f $(rm-files)
2274
f9c235fd
MY
2275# read all saved command lines
2276
b5a20463 2277cmd_files := $(wildcard .*.cmd $(foreach f,$(sort $(targets)),$(dir $(f)).$(notdir $(f)).cmd))
f9c235fd
MY
2278
2279ifneq ($(cmd_files),)
2280 $(cmd_files): ; # Do not try to update included dependency files
2281 include $(cmd_files)
2282endif
2283
9e414032
MY
2284endif # skip-makefile
2285
2286PHONY += FORCE
2287FORCE:
2288
5972ff07 2289# Declare the contents of the PHONY variable as phony. We keep that
9e414032
MY
2290# information in a variable so we can use it in if_changed and friends.
2291.PHONY: $(PHONY)
This page took 1.030292 seconds and 4 git commands to generate.